﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        int visibilityCount = 0;
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new LeagueList();
        }

        void CellValuePresenter_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            CellValuePresenter lp = sender as CellValuePresenter;

            if ((sender as CellValuePresenter).DataPresenter.FieldLayouts[0].Fields.Contains(lp.Field))
            {
                Field f = (sender as CellValuePresenter).DataPresenter.FieldLayouts[1].Fields[lp.Field.Index];
                f.Width = new FieldLength(lp.Field.CellWidthResolved);
            }

            if ((sender as CellValuePresenter).DataPresenter.FieldLayouts[1].Fields.Contains(lp.Field))
            {
                Field f = (sender as CellValuePresenter).DataPresenter.FieldLayouts[0].Fields[lp.Field.Index];
                f.Width = new FieldLength(lp.Field.CellWidthResolved);
            }

        }

        private void XamDataGrid_RecordExpanded(object sender, Infragistics.Windows.DataPresenter.Events.RecordExpandedEventArgs e)
        {
            visibilityCount++;
            (sender as XamDataGrid).FieldLayouts[0].Fields[1].Visibility = System.Windows.Visibility.Visible;
        }

        private void XamDataGrid_RecordCollapsed(object sender, Infragistics.Windows.DataPresenter.Events.RecordCollapsedEventArgs e)
        {
            if (--visibilityCount == 0)
                (sender as XamDataGrid).FieldLayouts[0].Fields[1].Visibility = System.Windows.Visibility.Collapsed;
        } 
    }

    public class Division
    {
        public string Name { get; set; }
    }

    public class League
    {
        public string Name { get; set; }
        public ObservableCollection<Division> Divisions { get; set; }
    }

    public class LeagueList : ObservableCollection<League>
    {
        public LeagueList()
        {
            for (int x = 1; x < 3; x++)
            {
                League theLeague = new League()
                {
                    Name = "League " + x,
                    Divisions = new ObservableCollection<Division>()
                };

                for (int y = 1; y < 4; y++)
                {
                    Division theDivision = new Division()
                    {
                        Name = String.Format("Division {0}-{1}", x, y)
                    };

                    theLeague.Divisions.Add(theDivision);
                }
                this.Add(theLeague);
            }
        }

    }
}
